<?php

/* NoPro sql-lib
 * some handy funcs using mysqli-object
 */

function sqlistore($dbo, $tbl, $arr, $idkey = null, $verbose = false, $keys = null) {
  /* the presence of $idkey, signals UPDATE instead of INSERT
   * $verbose means to print the query
   * $keys for non-associative $arr, or to override $k from $arr
   */
  $query = $idkey ? "UPDATE $tbl SET" : "INSERT INTO $tbl SET";
  foreach($arr as $k => $val) {
    $key = $keys ? $keys[$k] : $k;
    if(is_numeric($val))
      $query .= " $key = $val,";
    else if($val === null)
      $query .= " $key = NULL,";
    else
      $query .= " $key = '$val',";
  }
  $query = rtrim($query, ',');
  
  if($idkey)
    $query .= sprintf(" WHERE $idkey = %d", $arr[$idkey]);
  
  if($verbose)
    echo $query ."\n";
  
  $dbo->query($query) or die("sqlstore(): ". $dbo->error);
  if($idkey)
    $idval = $arr[$idkey];
  else
    $idval = $dbo->insert_id;
  return $idval;
}

function sqli2arr($dbo, $query) {
  // fill array with sql-results
  $arr = array();
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  while($row = $res->fetch_assoc()) {
    array_push($arr, $row);
  }
  $res->close();
  return $arr;
}

function sqli2arr1d($dbo, $query) {
  // fill 1d-array with sql-results
  $arr = array();
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  while($row = $res->fetch_row()) {
    array_push($arr, $row[0]);
  }
  $res->close();
  return $arr;
}
function sqli_tables($dbo) { return sqli2arr1d($dbo, 'SHOW TABLES'); }


/////
// following is exclusive to nopro_sqli
// no more further support of nopro_sql
/////


function sqli_coll($dbo, $query, $dim = 1) {
  // return array ('collection') as result of query
  if($dim > 1)
    return sqli2arr($dbo, $query);
  else
    return sqli2arr1d($dbo, $query);
}
  
function sqli_roster($dbo, $tbl) {
  // return array of fname => ftyype
  $ret = array();
  $xpl = sqli2arr($dbo, 'explain ' . $tbl);
  foreach($xpl as $arr) {
    $ret[$arr['Field']] = $arr['Type'];
  }
  return $ret;
}

function sqli_q2csv($dbo, $q, $out = '/dev/stdout') {
  // output query-result as csv
  $res = $dbo->query($q);
  if($res !== false && $res->num_rows > 0) {
    $fh = fopen($out, 'w') OR die("fopen($out)");
    $row = $res->fetch_assoc();
    fputcsv($fh, array_keys($row));
    fputcsv($fh, array_values($row));
    while($row = $res->fetch_assoc()) {
      fputcsv($fh, $row);
    }
    fclose($fh);  
    $res->close();
  }
}
  
?>